package com.ziplinegreen.vault.Service;


import com.ziplinegreen.vault.Controller.UserController;
import com.ziplinegreen.vault.Model.Post;
import com.ziplinegreen.vault.Model.User;
import com.ziplinegreen.vault.Repository.PostRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class PostService {

    private PostRepository postRepository;
    private UserController userController;

    @Autowired
    public PostService(PostRepository postRepository) {
        this.postRepository = postRepository;
    }

    public ResponseEntity<Post> createPost(Long userId, String message){
        Post post = new Post(message,userId);
        return new ResponseEntity<>(postRepository.save(post), HttpStatus.CREATED);
    }

    public ResponseEntity<Iterable<Post>> findAllByUserId(Long userId) {
        return new ResponseEntity<>(postRepository.findAllByUserId(userId), HttpStatus.OK);
    }

    public ResponseEntity<Post> updatePost(Long postId, String message) {
        Post post = findById(postId);
        post.setMessage(message);
        return new ResponseEntity<>(postRepository.save(post), HttpStatus.OK);
    }


    private Post findById(Long postId) {
        return postRepository.findById(postId).get();
    }

    public ResponseEntity<Post> getPostById(Long postId) {
        Post post = postRepository.getOne(postId);
        return new ResponseEntity<>(post, HttpStatus.OK);
    }

    public ResponseEntity<Post> deletePost(Long postId){
        Post post = postRepository.getOne(postId);
        postRepository.delete(post);
        return new ResponseEntity<>(HttpStatus.OK);
    }


//    public ResponseEntity<User> addpost(Long userId, Post post) {
//        User user = findUserById(userId).getBody();
//        List<Post> posts = user.getPosts();
//        posts.add(post);
//        return new ResponseEntity<>(userRepository.save(user), HttpStatus.OK);
//    }
}

