package com.ziplinegreen.vault.Service;

import com.ziplinegreen.vault.Controller.PostController;
import com.ziplinegreen.vault.Exception.ResourceNotFoundException;
import com.ziplinegreen.vault.Model.Post;
import com.ziplinegreen.vault.Model.User;
import com.ziplinegreen.vault.Repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.server.ResponseStatusException;

import javax.xml.ws.Response;
import java.util.List;

@Service
public class UserService {

    private UserRepository userRepository;
    //private PostController postController;

    @Autowired
    public UserService(UserRepository userRepository) {
        this.userRepository = userRepository;
    }

    public ResponseEntity<User> createUser(User user){
        return new ResponseEntity<>(userRepository.save(user), HttpStatus.CREATED);
    }

    public ResponseEntity<User> findUserById(Long id){
        return new ResponseEntity<>(userRepository.findById(id).get(),HttpStatus.OK);
    }

    public ResponseEntity<User> updateUsername(Long id, String newUsername) {
        User user = findUserById(id).getBody();
        user.setUsername(newUsername);
        return new ResponseEntity<>(userRepository.save(user),HttpStatus.OK);
    }

    public ResponseEntity deleteUser(Long id){
        userRepository.delete(userRepository.findById(id).get());
        return new ResponseEntity(HttpStatus.OK);
    }







}


